package xyz.brassgoggledcoders.moarcarts.mods.extras.tiles;

import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.ITickable;
import xyz.brassgoggledcoders.boilerplate.lib.common.tileentities.TileEntityFluidBase;
import xyz.brassgoggledcoders.moarcarts.mods.extras.block.BlockFluidHopper;

public class TileFluidHopper extends TileEntityFluidBase implements ITickable
{
	private int transferCoolDown = -1;

	@Override
	public void func_73660_a()
	{
		if (this.field_145850_b != null && !this.field_145850_b.field_72995_K)
		{
			--this.transferCoolDown;

			if (!this.isOnTransferCoolDown())
			{
				this.setTransferCoolDown(0);
				this.updateHopper();
			}
		}
	}

	private void updateHopper()
	{
		if (this.field_145850_b != null && !this.field_145850_b.field_72995_K)
		{
			if (!this.isOnTransferCoolDown() && BlockFluidHopper.isEnabled(this.func_145832_p()))
			{
				boolean flag = false;

				if (getTank().getFluidAmount() != 0)
				{
					flag = this.pushFluidTo(BlockFluidHopper.getFacing(this.func_145832_p()));
				}

				if (getTank().getFluidAmount() < getTank().getCapacity())
				{
					flag = this.pullFluidFrom(EnumFacing.UP)|| flag;
				}

				if (flag)
				{
					this.func_70296_d();
				}

				this.setTransferCoolDown(100);
			}
		}
	}

	@Override
	public void readFromNBTCustom(NBTTagCompound nbtTagCompound)
	{
		setTransferCoolDown(nbtTagCompound.func_74762_e("COOLDOWN"));
	}

	@Override
	public void writeToNBTCustom(NBTTagCompound nbtTagCompound)
	{
		nbtTagCompound.func_74768_a("COOLDOWN", this.transferCoolDown);
	}

	public boolean isOnTransferCoolDown()
	{
		return this.transferCoolDown > 0;
	}

	public void setTransferCoolDown(int transferCoolDown)
	{
		this.transferCoolDown = transferCoolDown;
	}

	@Override
	public int getCapacity()
	{
		return 16000;
	}

	@Override
	public int getTransferRate()
	{
		return 500;
	}
}
