package xyz.brassgoggledcoders.moarcarts.renderers;

import net.minecraft.block.state.IBlockState;
import net.minecraft.client.Minecraft;
import net.minecraft.client.model.ModelBase;
import net.minecraft.client.model.ModelMinecart;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.block.model.ItemCameraTransforms;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.client.renderer.tileentity.TileEntityRendererDispatcher;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.client.FMLClientHandler;
import xyz.brassgoggledcoders.boilerplate.lib.client.ClientHelper;
import xyz.brassgoggledcoders.boilerplate.lib.client.renderers.ItemSpecialRenderer;
import xyz.brassgoggledcoders.boilerplate.lib.client.renderers.math.DefaultTransformationMatrices;
import xyz.brassgoggledcoders.boilerplate.lib.client.renderers.math.TransformationMatrix;
import xyz.brassgoggledcoders.boilerplate.lib.common.utils.ItemStackUtils;
import xyz.brassgoggledcoders.moarcarts.items.ItemMinecartBase;

@SuppressWarnings("deprecation")
public class RenderItemMinecartBase extends ItemSpecialRenderer<RenderItemMinecartBase.DummyTile>
{
	private static final ResourceLocation minecartTextures = new ResourceLocation("textures/entity/minecart.png");
	protected ModelBase modelMinecart = new ModelMinecart();

	@Override
	public void renderItem(ItemStack stack, float partialTicks)
	{
		GlStateManager.func_179094_E();
		GlStateManager.func_179137_b(-0.5,0.5,-0.5);
		FMLClientHandler.instance().getClient().field_71446_o.func_110577_a(TextureMap.field_110575_b);

		GlStateManager.func_179094_E();
		GlStateManager.func_179114_b(270, 0, 1, 0);
		GlStateManager.func_179114_b(90, 0, 0, 1);
		GlStateManager.func_179152_a(12, 12, 12);

		GlStateManager.func_179109_b(0.0F, 6 / 16.0F, 0.0F);

		if(ItemStackUtils.isItemInstanceOf(stack, ItemMinecartBase.class))
		{
			ItemMinecartBase itemMinecartBase = (ItemMinecartBase)stack.func_77973_b();
			IBlockState blockState = itemMinecartBase.getCartBlockState(stack);
			switch(itemMinecartBase.getCartBlockRenderMethod(stack)) {
				case VMC:
				case ISBRH:
					this.renderVMCMethod(stack, itemMinecartBase, blockState);
					break;
				case TESR:
					this.renderTESRMethod(stack, itemMinecartBase, blockState);
					break;
				case CUSTOM:
					this.renderCustom(stack, itemMinecartBase);
					break;
				case COMBO:
					this.renderVMCMethod(stack, itemMinecartBase, blockState);
					break;
				default:
					break;
			}
		}

		GlStateManager.func_179121_F();
		GlStateManager.func_179114_b(-90, 0, 0, 1);
		GlStateManager.func_179114_b(-90, 1, 0, 0);
		GlStateManager.func_179152_a(-1, -1, 1);

		Minecraft.func_71410_x().func_110434_K().func_110577_a(minecartTextures);
		modelMinecart.func_78088_a(ClientHelper.player(), 0, 0, 0, 0, 0, 1);
		GlStateManager.func_179121_F();
	}

	protected void renderVMCMethod(ItemStack itemStack, ItemMinecartBase itemMinecartBase, IBlockState blockState)
	{
		if (blockState.func_177230_c().func_149645_b() != -1)
		{
			GlStateManager.func_179094_E();
			GlStateManager.func_179109_b(-0.5F, -0.5F, 0.5F);
			Minecraft.func_71410_x().func_175602_ab().func_175016_a(blockState, 15);
			GlStateManager.func_179121_F();
		}
	}

	protected void renderTESRMethod(ItemStack itemStack, ItemMinecartBase itemMinecartBase, IBlockState blockState)
	{
		rotateTESR();
		GlStateManager.func_179094_E();
		GlStateManager.func_179109_b(-0.5F, -0.5F, -0.5F);
		TileEntityRendererDispatcher.field_147556_a.func_147549_a(
					itemMinecartBase.getRenderTileEntity(itemStack, ClientHelper.world()), 0, 0, 0, 0.0F);
		GlStateManager.func_179121_F();
	}

	protected void renderCustom(ItemStack itemStack, ItemMinecartBase itemMinecartBase)
	{

	}

	protected void rotateTESR()
	{
		GlStateManager.func_179114_b(90, 0, 1, 0);
	}


	@Override
	@SuppressWarnings("deprecation")
	public TransformationMatrix getTransformMatrixForPerspective(ItemCameraTransforms.TransformType cameraTransformsType) {
		return DefaultTransformationMatrices.getTransformMatrixForPerspective(cameraTransformsType);
	}

	@Override
	public Class<DummyTile> getTileClass()
	{
		return DummyTile.class;
	}

	static class DummyTile extends TileEntity {}
}